"use strict";

const _ = require("lodash");
const startOfWeek = require("date-fns/start_of_week");
const isToday = require("date-fns/is_today");
const subWeeks = require("date-fns/sub_weeks");
const getHours = require("date-fns/get_hours");
const setHours = require("date-fns/set_hours");
const IssueEvaluator = require("./evaluators/issue-evaluator");
const MergeRequestReviewEvaluator = require("./evaluators/merge-request-review-evaluator");
const MergeRequestEvaluator = require("./evaluators/merge-request-evaluator");
const InstanceWalker = require("./instance-walker");
const purgeCache = require("./purge-cache");

const TEAM = new Set(["andrewn", "jacobvosmaer-gitlab", "marin", "msmiley", "reprazent", "rnienaber", "smcgivern"]);

const SECTIONS = {
  "Closed Issues": IssueEvaluator,
  "Merged Merge Requests": MergeRequestEvaluator,
  "Reviewed Merge Requests": MergeRequestReviewEvaluator
};

class StatusReportGenerator {
  constructor() {
    this.since = this.getStartTime();
    let Evaluators = Object.keys(SECTIONS).map(key => SECTIONS[key]);

    this.instanceWalkers = ["https://gitlab.com", "https://ops.gitlab.net"].map(instance => {
      let evaluators = Evaluators.map(Evaluator => new Evaluator(this.since, TEAM));

      return new InstanceWalker(instance, this.since, TEAM, evaluators);
    });
  }

  getStartTime() {
    var now = new Date();

    var wednesday = startOfWeek(now, { weekStartsOn: 3 });

    if (isToday(wednesday)) {
      if (getHours(now) < 16) {
        wednesday = subWeeks(wednesday, 1);
      }
    }

    // Switchover time is always 16h00UTC on a Wednesday
    return setHours(wednesday, 16);
  }

  renderMergedSection(evaluatorIndex) {
    let reportLines = this.instanceWalkers.map(instanceWalker => instanceWalker.evaluators[evaluatorIndex].render());
    reportLines = _.flatten(reportLines);

    let sorted = _.sortBy(reportLines, item => item[0].toLowerCase());
    return sorted.map(item => item[1]);
  }

  async getStatusReport() {
    await Promise.all(this.instanceWalkers.map(instanceWalker => instanceWalker.walk()));

    let bodyLines = ["# Scalability Status Update"];

    Object.keys(SECTIONS).forEach((section, index) => {
      let sectionLines = this.renderMergedSection(index);

      if (sectionLines.length) {
        bodyLines.push(`\n## ${section}\n`);
        bodyLines = bodyLines.concat(sectionLines);
      }
    });

    if (bodyLines.length === 1) return;

    bodyLines.push("\n-------------------------");
    bodyLines.push("\nThis status report was [autogenerated](https://gitlab.com/gitlab-com/gl-infra/scalability-report).");
    bodyLines.push("\n/confidential");

    return {
      since: this.since,
      body: bodyLines.join("\n")
    };
  }
}

async function statusReport() {
  try {
    let statusReportGenerator = new StatusReportGenerator();

    return await statusReportGenerator.getStatusReport();
  } finally {
    try {
      await purgeCache();
    } catch (e) {
      console.error("Cache purge failed: " + e);
    }
  }
}

module.exports = statusReport;
